use microrm::schema::entity::EntityPartList;

use super::Object;
use crate::{schema, UIDCError};

#[derive(clap::Parser, Debug)]
pub struct CreateParameters {
    username: String,
}

impl Object for schema::User {
    type CreateParameters = CreateParameters;

    fn create_from_params(cp: &Self::CreateParameters) -> Result<Self, UIDCError> {
        Ok(Self {
            username: cp.username.clone(),
            auth: Default::default(),
            groups: Default::default(),
        })
    }

    fn db_object(db: &schema::UIDCDatabase) -> &microrm::prelude::IDMap<Self>
    where
        Self: Sized,
    {
        todo!()
    }

    fn shortname(&self) -> &str {
        &self.username
    }
}
